"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessTokenGuard = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const rxjs_1 = require("rxjs");
const env_vars_const_1 = require("../models/consts/env-vars.const");
let AccessTokenGuard = class AccessTokenGuard {
    constructor(_configService) {
        this._configService = _configService;
    }
    canActivate(context) {
        const req = context.switchToHttp().getRequest();
        const token = req.headers['x-access-token'];
        if (!token || token !== this._configService.get(env_vars_const_1.APP__ACCESS_TOKEN)) {
            throw new common_1.UnauthorizedException();
        }
        return (0, rxjs_1.of)(true);
    }
};
exports.AccessTokenGuard = AccessTokenGuard;
exports.AccessTokenGuard = AccessTokenGuard = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [config_1.ConfigService])
], AccessTokenGuard);
//# sourceMappingURL=access-token.guard.js.map