import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { IRecord } from '../../interfaces/record.interface';
import { RecordState } from '../../enums/record-state.enum';

@Schema({ _id: false })
export class Record implements IRecord {
    @Prop({ type: String, enum: RecordState, required: true, default: RecordState.DRAFT })
    state: RecordState;

    @Prop({ type: Boolean, required: true, default: false })
    deleted: boolean;

    @Prop({ type: Date, required: true, default: Date.now })
    createdAt: Date;

    @Prop({ type: Date, required: false })
    updatedAt: Date;

    @Prop({ type: Date, required: false })
    deletedAt: Date;
}

export const RecordSchema = SchemaFactory.createForClass(Record);
export type RecordDocument = HydratedDocument<Record>;
