import { Schema, Prop, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { IResidence } from '../../interfaces/residence.interface';
import { IDictionary } from '../../interfaces/dictionary.interface';
import { DictionaryEmbeddedSchema } from './dictionary-embedded.schema';

@Schema({ _id: false })
export class Residence implements IResidence {
    @Prop({ type: DictionaryEmbeddedSchema, required: false, default: null })
    country: IDictionary;

    @Prop({ type: DictionaryEmbeddedSchema, required: false, default: null })
    city: IDictionary;

    @Prop({ type: String, required: false, default: null })
    address1: string;

    @Prop({ type: String, required: false, default: null })
    address2: string;
}

export const ResidenceSchema = SchemaFactory.createForClass(Residence);
export type ResidenceDocument = HydratedDocument<Residence>;
