import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { ISessionUser } from '../interfaces/session-user.interface';
import { ISession } from '../interfaces/session.interface';
import { SessionUserSchema } from './embedded/session-user.schema';
import { Identifable } from './identifable.schema';

@Schema()
export class Session extends Identifable implements ISession {
    @Prop({ type: String, unique: true, required: true })
    token: string;

    @Prop({ type: SessionUserSchema, required: true })
    user: ISessionUser;

    @Prop({ required: true })
    expiresAt: Date;

    @Prop({ required: true })
    userAgent: string;
}

export const SessionSchema = SchemaFactory.createForClass(Session);
export type SessionDocument = HydratedDocument<Session>;
